xref: /openbmc/linux/scripts/link-vmlinux.sh (revision 64288aa9)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
11#
12# vmlinux
13#   ^
14#   |
15#   +--< $(KBUILD_VMLINUX_OBJS)
16#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17#   |
18#   +--< $(KBUILD_VMLINUX_LIBS)
19#   |    +--< lib/lib.a + more
20#   |
21#   +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
37is_enabled() {
38	grep -q "^$1=y" include/config/auto.conf
39}
40
41# Nice output in kbuild format
42# Will be supressed by "make -s"
43info()
44{
45	printf "  %-7s %s\n" "${1}" "${2}"
46}
47
48# Generate a linker script to ensure correct ordering of initcalls.
49gen_initcalls()
50{
51	info GEN .tmp_initcalls.lds
52
53	${PYTHON} ${srctree}/scripts/jobserver-exec		\
54	${PERL} ${srctree}/scripts/generate_initcall_order.pl	\
55		${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}	\
56		> .tmp_initcalls.lds
57}
58
59# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
60# .tmp_symversions.lds
61gen_symversions()
62{
63	info GEN .tmp_symversions.lds
64	rm -f .tmp_symversions.lds
65
66	for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
67		if [ -f ${o}.symversions ]; then
68			cat ${o}.symversions >> .tmp_symversions.lds
69		fi
70	done
71}
72
73# Link of vmlinux.o used for section mismatch analysis
74# ${1} output file
75modpost_link()
76{
77	local objects
78	local lds=""
79
80	objects="--whole-archive				\
81		${KBUILD_VMLINUX_OBJS}				\
82		--no-whole-archive				\
83		--start-group					\
84		${KBUILD_VMLINUX_LIBS}				\
85		--end-group"
86
87	if is_enabled CONFIG_LTO_CLANG; then
88		gen_initcalls
89		lds="-T .tmp_initcalls.lds"
90
91		if is_enabled CONFIG_MODVERSIONS; then
92			gen_symversions
93			lds="${lds} -T .tmp_symversions.lds"
94		fi
95
96		# This might take a while, so indicate that we're doing
97		# an LTO link
98		info LTO ${1}
99	else
100		info LD ${1}
101	fi
102
103	${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
104}
105
106objtool_link()
107{
108	local objtoolcmd;
109	local objtoolopt;
110
111	if is_enabled CONFIG_LTO_CLANG && is_enabled CONFIG_STACK_VALIDATION; then
112		# Don't perform vmlinux validation unless explicitly requested,
113		# but run objtool on vmlinux.o now that we have an object file.
114		if is_enabled CONFIG_UNWINDER_ORC; then
115			objtoolcmd="orc generate"
116		fi
117
118		objtoolopt="${objtoolopt} --duplicate"
119
120		if is_enabled CONFIG_FTRACE_MCOUNT_USE_OBJTOOL; then
121			objtoolopt="${objtoolopt} --mcount"
122		fi
123	fi
124
125	if is_enabled CONFIG_VMLINUX_VALIDATION; then
126		objtoolopt="${objtoolopt} --noinstr"
127	fi
128
129	if [ -n "${objtoolopt}" ]; then
130		if [ -z "${objtoolcmd}" ]; then
131			objtoolcmd="check"
132		fi
133		objtoolopt="${objtoolopt} --vmlinux"
134		if ! is_enabled CONFIG_FRAME_POINTER; then
135			objtoolopt="${objtoolopt} --no-fp"
136		fi
137		if is_enabled CONFIG_GCOV_KERNEL || is_enabled CONFIG_LTO_CLANG; then
138			objtoolopt="${objtoolopt} --no-unreachable"
139		fi
140		if is_enabled CONFIG_RETPOLINE; then
141			objtoolopt="${objtoolopt} --retpoline"
142		fi
143		if is_enabled CONFIG_X86_SMAP; then
144			objtoolopt="${objtoolopt} --uaccess"
145		fi
146		if is_enabled CONFIG_SLS; then
147			objtoolopt="${objtoolopt} --sls"
148		fi
149		info OBJTOOL ${1}
150		tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
151	fi
152}
153
154# Link of vmlinux
155# ${1} - output file
156# ${2}, ${3}, ... - optional extra .o files
157vmlinux_link()
158{
159	local output=${1}
160	local objs
161	local libs
162	local ld
163	local ldflags
164	local ldlibs
165
166	info LD ${output}
167
168	# skip output file argument
169	shift
170
171	if is_enabled CONFIG_LTO_CLANG; then
172		# Use vmlinux.o instead of performing the slow LTO link again.
173		objs=vmlinux.o
174		libs=
175	else
176		objs="${KBUILD_VMLINUX_OBJS}"
177		libs="${KBUILD_VMLINUX_LIBS}"
178	fi
179
180	if [ "${SRCARCH}" = "um" ]; then
181		wl=-Wl,
182		ld="${CC}"
183		ldflags="${CFLAGS_vmlinux}"
184		ldlibs="-lutil -lrt -lpthread"
185	else
186		wl=
187		ld="${LD}"
188		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
189		ldlibs=
190	fi
191
192	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
193
194	# The kallsyms linking does not need debug symbols included.
195	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
196		ldflags="${ldflags} ${wl}--strip-debug"
197	fi
198
199	if is_enabled CONFIG_VMLINUX_MAP; then
200		ldflags="${ldflags} ${wl}-Map=${output}.map"
201	fi
202
203	${ld} ${ldflags} -o ${output}					\
204		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
205		${wl}--start-group ${libs} ${wl}--end-group		\
206		$@ ${ldlibs}
207}
208
209# generate .BTF typeinfo from DWARF debuginfo
210# ${1} - vmlinux image
211# ${2} - file to dump raw BTF data into
212gen_btf()
213{
214	local pahole_ver
215
216	if ! [ -x "$(command -v ${PAHOLE})" ]; then
217		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
218		return 1
219	fi
220
221	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
222	if [ "${pahole_ver}" -lt "116" ]; then
223		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
224		return 1
225	fi
226
227	vmlinux_link ${1}
228
229	info "BTF" ${2}
230	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
231
232	# Create ${2} which contains just .BTF section but no symbols. Add
233	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
234	# deletes all symbols including __start_BTF and __stop_BTF, which will
235	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
236	# objcopy warnings: "empty loadable segment detected at ..."
237	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
238		--strip-all ${1} ${2} 2>/dev/null
239	# Change e_type to ET_REL so that it can be used to link final vmlinux.
240	# Unlike GNU ld, lld does not allow an ET_EXEC input.
241	printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
242}
243
244# Create ${2} .S file with all symbols from the ${1} object file
245kallsyms()
246{
247	local kallsymopt;
248
249	if is_enabled CONFIG_KALLSYMS_ALL; then
250		kallsymopt="${kallsymopt} --all-symbols"
251	fi
252
253	if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
254		kallsymopt="${kallsymopt} --absolute-percpu"
255	fi
256
257	if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
258		kallsymopt="${kallsymopt} --base-relative"
259	fi
260
261	info KSYMS ${2}
262	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
263}
264
265# Perform one step in kallsyms generation, including temporary linking of
266# vmlinux.
267kallsyms_step()
268{
269	kallsymso_prev=${kallsymso}
270	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
271	kallsymso=${kallsyms_vmlinux}.o
272	kallsyms_S=${kallsyms_vmlinux}.S
273
274	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
275	kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
276
277	info AS ${kallsyms_S}
278	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
279	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
280	      -c -o ${kallsymso} ${kallsyms_S}
281}
282
283# Create map file with all symbols from ${1}
284# See mksymap for additional details
285mksysmap()
286{
287	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
288}
289
290sorttable()
291{
292	${objtree}/scripts/sorttable ${1}
293}
294
295# Delete output files in case of error
296cleanup()
297{
298	rm -f .btf.*
299	rm -f .tmp_System.map
300	rm -f .tmp_initcalls.lds
301	rm -f .tmp_symversions.lds
302	rm -f .tmp_vmlinux*
303	rm -f System.map
304	rm -f vmlinux
305	rm -f vmlinux.map
306	rm -f vmlinux.o
307	rm -f .vmlinux.d
308}
309
310# Use "make V=1" to debug this script
311case "${KBUILD_VERBOSE}" in
312*1*)
313	set -x
314	;;
315esac
316
317if [ "$1" = "clean" ]; then
318	cleanup
319	exit 0
320fi
321
322# Update version
323info GEN .version
324if [ -r .version ]; then
325	VERSION=$(expr 0$(cat .version) + 1)
326	echo $VERSION > .version
327else
328	rm -f .version
329	echo 1 > .version
330fi;
331
332# final build of init/
333${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
334
335#link vmlinux.o
336modpost_link vmlinux.o
337objtool_link vmlinux.o
338
339# modpost vmlinux.o to check for section mismatches
340${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
341
342info MODINFO modules.builtin.modinfo
343${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
344info GEN modules.builtin
345# The second line aids cases where multiple modules share the same object.
346tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
347	tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
348
349btf_vmlinux_bin_o=""
350if is_enabled CONFIG_DEBUG_INFO_BTF; then
351	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
352	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
353		echo >&2 "Failed to generate BTF for vmlinux"
354		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
355		exit 1
356	fi
357fi
358
359kallsymso=""
360kallsymso_prev=""
361kallsyms_vmlinux=""
362if is_enabled CONFIG_KALLSYMS; then
363
364	# kallsyms support
365	# Generate section listing all symbols and add it into vmlinux
366	# It's a three step process:
367	# 1)  Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
368	#     but __kallsyms is empty.
369	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
370	#     the right size
371	# 2)  Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
372	#     the right size, but due to the added section, some
373	#     addresses have shifted.
374	#     From here, we generate a correct .tmp_vmlinux.kallsyms2.o
375	# 3)  That link may have expanded the kernel image enough that
376	#     more linker branch stubs / trampolines had to be added, which
377	#     introduces new names, which further expands kallsyms. Do another
378	#     pass if that is the case. In theory it's possible this results
379	#     in even more stubs, but unlikely.
380	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
381	#     other bugs.
382	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
383	#
384	# a)  Verify that the System.map from vmlinux matches the map from
385	#     ${kallsymso}.
386
387	kallsyms_step 1
388	kallsyms_step 2
389
390	# step 3
391	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
392	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
393
394	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
395		kallsyms_step 3
396	fi
397fi
398
399vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
400
401# fill in BTF IDs
402if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
403	info BTFIDS vmlinux
404	${RESOLVE_BTFIDS} vmlinux
405fi
406
407info SYSMAP System.map
408mksysmap vmlinux System.map
409
410if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
411	info SORTTAB vmlinux
412	if ! sorttable vmlinux; then
413		echo >&2 Failed to sort kernel tables
414		exit 1
415	fi
416fi
417
418# step a (see comment above)
419if is_enabled CONFIG_KALLSYMS; then
420	mksysmap ${kallsyms_vmlinux} .tmp_System.map
421
422	if ! cmp -s System.map .tmp_System.map; then
423		echo >&2 Inconsistent kallsyms data
424		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
425		exit 1
426	fi
427fi
428
429# For fixdep
430echo "vmlinux: $0" > .vmlinux.d
431